# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xvhd`](#dsc_xvhd): The DSC xVHD resource type. Automatically generated from version 3.18.0
* [`dsc_xvhdfile`](#dsc_xvhdfile): The DSC xVhdFile resource type. Automatically generated from version 3.18.0
* [`dsc_xvmdvddrive`](#dsc_xvmdvddrive): The DSC xVMDvdDrive resource type. Automatically generated from version 3.18.0
* [`dsc_xvmharddiskdrive`](#dsc_xvmharddiskdrive): The DSC xVMHardDiskDrive resource type. Automatically generated from version 3.18.0
* [`dsc_xvmhost`](#dsc_xvmhost): The DSC xVMHost resource type. Automatically generated from version 3.18.0
* [`dsc_xvmhyperv`](#dsc_xvmhyperv): The DSC xVMHyperV resource type. Automatically generated from version 3.18.0
* [`dsc_xvmnetworkadapter`](#dsc_xvmnetworkadapter): The DSC xVMNetworkAdapter resource type. Automatically generated from version 3.18.0
* [`dsc_xvmprocessor`](#dsc_xvmprocessor): The DSC xVMProcessor resource type. Automatically generated from version 3.18.0
* [`dsc_xvmscsicontroller`](#dsc_xvmscsicontroller): The DSC xVMScsiController resource type. Automatically generated from version 3.18.0
* [`dsc_xvmswitch`](#dsc_xvmswitch): The DSC xVMSwitch resource type. Automatically generated from version 3.18.0

## Resource types

### <a name="dsc_xvhd"></a>`dsc_xvhd`

The DSC xVHD resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvhd` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Should the VHD be created or deleted

##### `dsc_filesizebytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Current size of the VHD

##### `dsc_generation`

Data type: `Optional[Enum['Vhd', 'vhd', 'Vhdx', 'vhdx']]`

Virtual disk format - Vhd or Vhdx

##### `dsc_id`

Data type: `Optional[String]`

Virtual Disk Identifier

##### `dsc_isattached`

Data type: `Optional[Boolean]`

Is the VHD attached to a VM or not

##### `dsc_maximumsizebytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Maximum size of Vhd to be created

##### `dsc_parentpath`

Data type: `Optional[String]`

Parent VHD file path, for differencing disk

##### `dsc_type`

Data type: `Optional[Enum['Dynamic', 'dynamic', 'Fixed', 'fixed', 'Differencing', 'differencing']]`

Type of Vhd - Dynamic, Fixed, Differencing

#### Parameters

The following parameters are available in the `dsc_xvhd` type.

* [`dsc_name`](#-dsc_xvhd--dsc_name)
* [`dsc_path`](#-dsc_xvhd--dsc_path)
* [`dsc_psdscrunascredential`](#-dsc_xvhd--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvhd--dsc_timeout)
* [`name`](#-dsc_xvhd--name)
* [`validation_mode`](#-dsc_xvhd--validation_mode)

##### <a name="-dsc_xvhd--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the VHD File

##### <a name="-dsc_xvhd--dsc_path"></a>`dsc_path`

namevar

Data type: `String`

Folder where the VHD will be created

##### <a name="-dsc_xvhd--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvhd--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvhd--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvhd--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvhdfile"></a>`dsc_xvhdfile`

The DSC xVhdFile resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvhdfile` type.

##### `dsc_checksum`

Data type: `Optional[Enum['ModifiedDate', 'modifieddate', 'SHA-1', 'sha-1', 'SHA-256', 'sha-256', 'SHA-512', 'sha-512']]`

 

##### `dsc_filedirectory`

Data type: `Array[Struct[{
              type => Optional[Enum['File', 'file', 'Directory', 'directory']],
              ensure => Optional[Enum['Present', 'present', 'Absent', 'absent']],
              content => Optional[String],
              destinationpath => String,
              force => Optional[Boolean],
              sourcepath => Optional[String],
              attributes => Optional[Array[Enum['ReadOnly', 'readonly', 'Hidden', 'hidden', 'System', 'system', 'Archive', 'archive']]],
              recurse => Optional[Boolean]
            }]]`

The FileDirectory objects to copy to the VHD

#### Parameters

The following parameters are available in the `dsc_xvhdfile` type.

* [`dsc_psdscrunascredential`](#-dsc_xvhdfile--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvhdfile--dsc_timeout)
* [`dsc_vhdpath`](#-dsc_xvhdfile--dsc_vhdpath)
* [`name`](#-dsc_xvhdfile--name)
* [`validation_mode`](#-dsc_xvhdfile--validation_mode)

##### <a name="-dsc_xvhdfile--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvhdfile--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvhdfile--dsc_vhdpath"></a>`dsc_vhdpath`

namevar

Data type: `String`

Path to the VHD

##### <a name="-dsc_xvhdfile--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvhdfile--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmdvddrive"></a>`dsc_xvmdvddrive`

The DSC xVMDvdDrive resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmdvddrive` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the DVD Drive should exist or not.

##### `dsc_path`

Data type: `Optional[String]`

Specifies the full path to the virtual hard disk file or physical hard disk volume for the added DVD drive.

#### Parameters

The following parameters are available in the `dsc_xvmdvddrive` type.

* [`dsc_controllerlocation`](#-dsc_xvmdvddrive--dsc_controllerlocation)
* [`dsc_controllernumber`](#-dsc_xvmdvddrive--dsc_controllernumber)
* [`dsc_psdscrunascredential`](#-dsc_xvmdvddrive--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmdvddrive--dsc_timeout)
* [`dsc_vmname`](#-dsc_xvmdvddrive--dsc_vmname)
* [`name`](#-dsc_xvmdvddrive--name)
* [`validation_mode`](#-dsc_xvmdvddrive--validation_mode)

##### <a name="-dsc_xvmdvddrive--dsc_controllerlocation"></a>`dsc_controllerlocation`

namevar

Data type: `Integer[0, 4294967295]`

Specifies the number of the location on the controller at which the DVD drive is to be added.

##### <a name="-dsc_xvmdvddrive--dsc_controllernumber"></a>`dsc_controllernumber`

namevar

Data type: `Integer[0, 4294967295]`

Specifies the number of the controller to which the DVD drive is to be added.

##### <a name="-dsc_xvmdvddrive--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmdvddrive--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmdvddrive--dsc_vmname"></a>`dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine to which the DVD drive is to be added.

##### <a name="-dsc_xvmdvddrive--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmdvddrive--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmharddiskdrive"></a>`dsc_xvmharddiskdrive`

The DSC xVMHardDiskDrive resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmharddiskdrive` type.

##### `dsc_controllerlocation`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of the location on the controller where the disk is attached. If not specified, it defaults to 0.

##### `dsc_controllernumber`

Data type: `Optional[Enum['0', '1', '2', '3']]`

Specifies the number of the controller where the disk is attached. If not specified, it defaults to 0.

##### `dsc_controllertype`

Data type: `Optional[Enum['IDE', 'ide', 'SCSI', 'scsi']]`

Specifies the controller type - IDE/SCSI where the disk is attached. If not specified, it defaults to SCSI.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the hard disk drive must be present or absent. If not specified, it defaults to Present.

#### Parameters

The following parameters are available in the `dsc_xvmharddiskdrive` type.

* [`dsc_path`](#-dsc_xvmharddiskdrive--dsc_path)
* [`dsc_psdscrunascredential`](#-dsc_xvmharddiskdrive--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmharddiskdrive--dsc_timeout)
* [`dsc_vmname`](#-dsc_xvmharddiskdrive--dsc_vmname)
* [`name`](#-dsc_xvmharddiskdrive--name)
* [`validation_mode`](#-dsc_xvmharddiskdrive--validation_mode)

##### <a name="-dsc_xvmharddiskdrive--dsc_path"></a>`dsc_path`

namevar

Data type: `String`

Specifies the full path to the location of the VHD that represents the hard disk drive.

##### <a name="-dsc_xvmharddiskdrive--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmharddiskdrive--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmharddiskdrive--dsc_vmname"></a>`dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine whose hard disk drive is to be manipulated.

##### <a name="-dsc_xvmharddiskdrive--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmharddiskdrive--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmhost"></a>`dsc_xvmhost`

The DSC xVMHost resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmhost` type.

##### `dsc_enableenhancedsessionmode`

Data type: `Optional[Boolean]`

Indicates whether users can use enhanced mode when they connect to virtual machines on this server by using Virtual Machine Connection.

##### `dsc_fibrechannelwwnn`

Data type: `Optional[String]`

Specifies the default value of the World Wide Node Name on the Hyper-V host.

##### `dsc_fibrechannelwwpnmaximum`

Data type: `Optional[String]`

Specifies the maximum value that can be used to generate World Wide Port Names on the Hyper-V host.

##### `dsc_fibrechannelwwpnminimum`

Data type: `Optional[String]`

Specifies the minimum value that can be used to generate the World Wide Port Names on the Hyper-V host.

##### `dsc_macaddressmaximum`

Data type: `Optional[String]`

Specifies the maximum MAC address using a valid hexadecimal value.

##### `dsc_macaddressminimum`

Data type: `Optional[String]`

Specifies the minimum MAC address using a valid hexadecimal value.

##### `dsc_maximumstoragemigrations`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of storage migrations that can be performed at the same time on the Hyper-V host.

##### `dsc_maximumvirtualmachinemigrations`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of live migrations that can be performed at the same time on the Hyper-V host.

##### `dsc_numaspanningenabled`

Data type: `Optional[Boolean]`

Specifies whether virtual machines on the Hyper-V host can use resources from more than one NUMA node.

##### `dsc_resourcemeteringsaveintervalminute`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how often the Hyper-V host saves the data that tracks resource usage. The range is a minimum of 60 minutes to a maximum of 1440 (24 hours).

##### `dsc_useanynetworkformigration`

Data type: `Optional[Boolean]`

Specifies how networks are selected for incoming live migration traffic.

##### `dsc_virtualharddiskpath`

Data type: `Optional[String]`

Specifies the default folder to store virtual hard disks on the Hyper-V host.

##### `dsc_virtualmachinemigrationauthenticationtype`

Data type: `Optional[Enum['CredSSP', 'credssp', 'Kerberos', 'kerberos']]`

Specifies the type of authentication to be used for live migrations. The acceptable values for this parameter are 'Kerberos' and 'CredSSP'.

##### `dsc_virtualmachinemigrationenabled`

Data type: `Optional[Boolean]`

Indicates whether Live Migration should be enabled or disabled on the Hyper-V host.

##### `dsc_virtualmachinemigrationperformanceoption`

Data type: `Optional[Enum['TCPIP', 'tcpip', 'Compression', 'compression', 'SMB', 'smb']]`

Specifies the performance option to use for live migration. The acceptable values for this parameter are 'TCPIP', 'Compression' and 'SMB'.

##### `dsc_virtualmachinepath`

Data type: `Optional[String]`

Specifies the default folder to store virtual machine configuration files on the Hyper-V host.

#### Parameters

The following parameters are available in the `dsc_xvmhost` type.

* [`dsc_issingleinstance`](#-dsc_xvmhost--dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#-dsc_xvmhost--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmhost--dsc_timeout)
* [`name`](#-dsc_xvmhost--name)
* [`validation_mode`](#-dsc_xvmhost--validation_mode)

##### <a name="-dsc_xvmhost--dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes', 'yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### <a name="-dsc_xvmhost--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmhost--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmhost--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmhost--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmhyperv"></a>`dsc_xvmhyperv`

The DSC xVMHyperV resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmhyperv` type.

##### `dsc_automaticcheckpointsenabled`

Data type: `Optional[Boolean]`

Enable AutomaticCheckpoints for the VM.

##### `dsc_cpuusage`

Data type: `Optional[Integer[0, 4294967295]]`

CPU Usage of the VM

##### `dsc_creationtime`

Data type: `Optional[Timestamp]`

Creation time of the VM

##### `dsc_enableguestservice`

Data type: `Optional[Boolean]`

Enable Guest Service Interface for the VM.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Should the VM be created or deleted

##### `dsc_generation`

Data type: `Optional[Integer[0, 4294967295]]`

Virtual machine generation

##### `dsc_hasdynamicmemory`

Data type: `Optional[Boolean]`

Does VM has dynamic memory enabled

##### `dsc_id`

Data type: `Optional[String]`

VM unique ID

##### `dsc_macaddress`

Data type: `Optional[Array[String]]`

MAC address(es) of the VM NICs.

##### `dsc_maximummemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Maximum RAM for the VM. This enable dynamic memory.

##### `dsc_memoryassigned`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Memory assigned to the VM

##### `dsc_minimummemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Minimum RAM for the VM. This enables dynamic memory.

##### `dsc_networkadapters`

Data type: `Optional[Array[String]]`

Network adapters' IP addresses of the VM

##### `dsc_notes`

Data type: `Optional[String]`

Notes about the VM.

##### `dsc_path`

Data type: `Optional[String]`

Folder where the VM data will be stored

##### `dsc_processorcount`

Data type: `Optional[Integer[0, 4294967295]]`

Processor count for the VM

##### `dsc_restartifneeded`

Data type: `Optional[Boolean]`

If specified, shutdowns and restarts the VM as needed for property changes

##### `dsc_secureboot`

Data type: `Optional[Boolean]`

Enable secure boot for Generation 2 VMs.

##### `dsc_startupmemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Startup RAM for the VM.

##### `dsc_state`

Data type: `Optional[Enum['Running', 'running', 'Paused', 'paused', 'Off', 'off']]`

State of the VM.

##### `dsc_status`

Data type: `Optional[String]`

Status of the VM

##### `dsc_switchname`

Data type: `Optional[Array[String]]`

Virtual switch(es) associated with the VM

##### `dsc_uptime`

Data type: `Optional[String]`

Uptime of the VM

##### `dsc_vhdpath`

Data type: `String`

VHD associated with the VM

##### `dsc_waitforip`

Data type: `Optional[Boolean]`

Waits for VM to get valid IP address.

#### Parameters

The following parameters are available in the `dsc_xvmhyperv` type.

* [`dsc_name`](#-dsc_xvmhyperv--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xvmhyperv--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmhyperv--dsc_timeout)
* [`name`](#-dsc_xvmhyperv--name)
* [`validation_mode`](#-dsc_xvmhyperv--validation_mode)

##### <a name="-dsc_xvmhyperv--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the VM

##### <a name="-dsc_xvmhyperv--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmhyperv--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmhyperv--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmhyperv--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmnetworkadapter"></a>`dsc_xvmnetworkadapter`

The DSC xVMNetworkAdapter resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmnetworkadapter` type.

##### `dsc_dynamicmacaddress`

Data type: `Optional[Boolean]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

 

##### `dsc_macaddress`

Data type: `Optional[String]`

 

##### `dsc_name`

Data type: `String`

 

##### `dsc_networksetting`

Data type: `Optional[Struct[{
              subnet => Optional[String],
              ipaddress => Optional[String],
              dnsserver => Optional[String],
              defaultgateway => Optional[String]
            }]]`

 

##### `dsc_switchname`

Data type: `String`

 

##### `dsc_vlanid`

Data type: `Optional[String]`

 

##### `dsc_vmname`

Data type: `String`

 

#### Parameters

The following parameters are available in the `dsc_xvmnetworkadapter` type.

* [`dsc_id`](#-dsc_xvmnetworkadapter--dsc_id)
* [`dsc_psdscrunascredential`](#-dsc_xvmnetworkadapter--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmnetworkadapter--dsc_timeout)
* [`name`](#-dsc_xvmnetworkadapter--name)
* [`validation_mode`](#-dsc_xvmnetworkadapter--validation_mode)

##### <a name="-dsc_xvmnetworkadapter--dsc_id"></a>`dsc_id`

namevar

Data type: `String`

 

##### <a name="-dsc_xvmnetworkadapter--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmnetworkadapter--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmnetworkadapter--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmnetworkadapter--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmprocessor"></a>`dsc_xvmprocessor`

The DSC xVMProcessor resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmprocessor` type.

##### `dsc_compatibilityformigrationenabled`

Data type: `Optional[Boolean]`

Specifies whether the virtual processors features are to be limited for compatibility when migrating the virtual machine to another host.

##### `dsc_compatibilityforolderoperatingsystemsenabled`

Data type: `Optional[Boolean]`

Specifies whether the virtual processorâ??s features are to be limited for compatibility with older operating systems.

##### `dsc_enablehostresourceprotection`

Data type: `Optional[Boolean]`

Specifies whether to enable host resource protection.

##### `dsc_exposevirtualizationextensions`

Data type: `Optional[Boolean]`

Specifies whether nested virtualization is enabled.

##### `dsc_hwthreadcountpercore`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the maximum thread core per processor core.

##### `dsc_maximum`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the maximum percentage of resources available to the virtual machine processor to be configured. Allowed values range from 0 to 100.

##### `dsc_maximumcountpernumanode`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of processors per NUMA node to be configured for the virtual machine.

##### `dsc_maximumcountpernumasocket`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of sockets per NUMA node to be configured for the virtual machine.

##### `dsc_relativeweight`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the priority for allocating the physical computer's processing power to this virtual machine relative to others. Allowed values range from 1 to 10000.

##### `dsc_reserve`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the percentage of processor resources to be reserved for this virtual machine. Allowed values range from 0 to 100.

##### `dsc_resourcepoolname`

Data type: `Optional[String]`

Specifies the name of the processor resource pool to be used.

##### `dsc_restartifneeded`

Data type: `Optional[Boolean]`

If specified, shutdowns and restarts the VM if needed for property changes.

#### Parameters

The following parameters are available in the `dsc_xvmprocessor` type.

* [`dsc_psdscrunascredential`](#-dsc_xvmprocessor--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmprocessor--dsc_timeout)
* [`dsc_vmname`](#-dsc_xvmprocessor--dsc_vmname)
* [`name`](#-dsc_xvmprocessor--name)
* [`validation_mode`](#-dsc_xvmprocessor--validation_mode)

##### <a name="-dsc_xvmprocessor--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmprocessor--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmprocessor--dsc_vmname"></a>`dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine on which the processor is to be configured.

##### <a name="-dsc_xvmprocessor--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmprocessor--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmscsicontroller"></a>`dsc_xvmscsicontroller`

The DSC xVMScsiController resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmscsicontroller` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the SCSI controller should exist or not. If not specified, it defaults to Present.

##### `dsc_restartifneeded`

Data type: `Optional[Boolean]`

Specifies if the VM should be restarted if needed for property changes. If not specified, it defaults to False.

#### Parameters

The following parameters are available in the `dsc_xvmscsicontroller` type.

* [`dsc_controllernumber`](#-dsc_xvmscsicontroller--dsc_controllernumber)
* [`dsc_psdscrunascredential`](#-dsc_xvmscsicontroller--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmscsicontroller--dsc_timeout)
* [`dsc_vmname`](#-dsc_xvmscsicontroller--dsc_vmname)
* [`name`](#-dsc_xvmscsicontroller--name)
* [`validation_mode`](#-dsc_xvmscsicontroller--validation_mode)

##### <a name="-dsc_xvmscsicontroller--dsc_controllernumber"></a>`dsc_controllernumber`

namevar

Data type: `Enum['0', '1', '2', '3']`

Specifies the number of the SCSI controller whose status is to be controlled. If not specified, it defaults to 0.

##### <a name="-dsc_xvmscsicontroller--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmscsicontroller--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmscsicontroller--dsc_vmname"></a>`dsc_vmname`

namevar

Data type: `String`

Specifies the name of the virtual machine whose SCSI controller status is to be controlled

##### <a name="-dsc_xvmscsicontroller--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmscsicontroller--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xvmswitch"></a>`dsc_xvmswitch`

The DSC xVMSwitch resource type.
Automatically generated from version 3.18.0

#### Properties

The following properties are available in the `dsc_xvmswitch` type.

##### `dsc_allowmanagementos`

Data type: `Optional[Boolean]`

Specify if the VM host has access to the physical NIC

##### `dsc_bandwidthreservationmode`

Data type: `Optional[Enum['Default', 'default', 'Weight', 'weight', 'Absolute', 'absolute', 'None', 'none', 'NA', 'na']]`

Type of Bandwidth Reservation Mode to use for the switch

##### `dsc_enableembeddedteaming`

Data type: `Optional[Boolean]`

Should embedded NIC teaming be used (Windows Server 2016 only)

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Whether switch should be present or absent

##### `dsc_id`

Data type: `Optional[String]`

Unique ID for the switch (Only settable on Windows Server 2016!)

##### `dsc_loadbalancingalgorithm`

Data type: `Optional[Enum['Dynamic', 'dynamic', 'HyperVPort', 'hypervport']]`

Specifies the load balancing algorithm that this switch team uses

##### `dsc_netadapterinterfacedescription`

Data type: `Optional[String]`

Description of the network interface

##### `dsc_netadaptername`

Data type: `Optional[Array[String]]`

Network adapter name(s) for external switch type

#### Parameters

The following parameters are available in the `dsc_xvmswitch` type.

* [`dsc_name`](#-dsc_xvmswitch--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xvmswitch--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xvmswitch--dsc_timeout)
* [`dsc_type`](#-dsc_xvmswitch--dsc_type)
* [`name`](#-dsc_xvmswitch--name)
* [`validation_mode`](#-dsc_xvmswitch--validation_mode)

##### <a name="-dsc_xvmswitch--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the VM Switch

##### <a name="-dsc_xvmswitch--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Variant[String[1], Sensitive[String[1]]] }]]`

 

##### <a name="-dsc_xvmswitch--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xvmswitch--dsc_type"></a>`dsc_type`

namevar

Data type: `Enum['External', 'external', 'Internal', 'internal', 'Private', 'private']`

Type of switch

##### <a name="-dsc_xvmswitch--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xvmswitch--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

